#include "Board.h"
#include "SPI.h"
//#include "math.h"

/*----------- INIT COMMAND LS020 -----------*/
const unsigned int  INIT0[2]={0xFDFD,0xFDFD};
const unsigned int  INIT1[12]={0xEF00,0xEE04,0x1B04,0xFEFE,0xFEFE,0xEF90,0x4A04,0x7F3F,0xEE04,0x4306};
const unsigned int  INIT2[20]={0xEF90,0x0983,0x0800,0x0BAF,0x0A00,0x0500,0x0600,0x0700,0xEF00,0xEE0C,0xEF90,0x0080,0xEFB0,0x4902,0xEF00,0x7F01,0xE181,0xE202,0xE276,0xE183};
const unsigned int  INIT3[3]={0x8001,0xEF90,0x0000};
const unsigned int  INIT4[4]={0xEF90, 0x0504, 0x0600, 0x0700};

unsigned int video_buffer[1][1];
#define Wait_PDC_SPI    while (((AT91C_BASE_SPI->SPI_SR) & AT91C_SPI_TXBUFE))
//
//#define _buffer 
//------------------------------------
//   1    !!!
//------------------------------------





void delaySF_ms(unsigned int ms)
{
  while(ms--)
  {
    __no_operation(); 
    __no_operation();
 /* __no_operation();
    __no_operation();
    __no_operation();
    __no_operation();
    __no_operation();
    __no_operation();
    __no_operation();
    __no_operation();
    __no_operation();
    __no_operation();
    __no_operation();
    __no_operation();
    __no_operation();
    __no_operation();
    __no_operation();
    __no_operation();
    __no_operation();
    __no_operation();
    __no_operation();
    */
  }
}

//====================================================================
void delay_ms(unsigned int ms)
{
  while(ms--)
  {
    delaySF_ms(19500);  
  }
}  


//====================================================================
void Init_SPI2(void)
{
 unsigned int cs;
  AT91PS_SPI pSPI = AT91C_BASE_SPI;
  AT91PS_PMC pPMC = AT91C_BASE_PMC;
  AT91PS_PIO pPIO = AT91C_BASE_PIOA;
  pPIO->PIO_PDR = SPI_MASK;
  pPIO->PIO_ASR = SPI_MASK;
  pPMC->PMC_PCER = 1<<AT91C_ID_SPI;
  pSPI->SPI_CR = AT91C_SPI_SPIEN | AT91C_SPI_SWRST;
  pSPI->SPI_MR = AT91C_SPI_MSTR ;
  
  cs=((0x02)<<8);
  cs|=AT91C_SPI_BITS_16  |AT91C_SPI_CPOL;//| AT91C_SPI_NCPHA 
  pSPI->SPI_CSR[0]=cs; 
  
//  AT91F_SPI_CfgMode(AT91C_SPI_CSR,cs); 
  
  pSPI->SPI_CR = AT91C_SPI_SPIEN;
}

//====================================================================
void Init_SPI(void)   // SPI 
{
  unsigned int cs;
  AT91PS_SPI pSPI = AT91C_BASE_SPI;
  AT91PS_PMC pPMC = AT91C_BASE_PMC;
  AT91PS_PIO pPIO = AT91C_BASE_PIOA;
  pPIO->PIO_PDR = SPI_MASK;
  pPIO->PIO_ASR = SPI_MASK;
  pPMC->PMC_PCER = 1<<AT91C_ID_SPI;
  pSPI->SPI_CR = AT91C_SPI_SPIEN | AT91C_SPI_SWRST;
  pSPI->SPI_MR = AT91C_SPI_MSTR ;
  
//  cs=((0x04)<<8); //speed SPI 12Mhz
//  cs=((0x03)<<8); //speed SPI 16Mhz
//  cs=((0x02)<<8); //speed SPI 24Mhz
  cs=((0x09)<<8); //speed SPI 5.339Mhz = 48054857/0x09
  cs|=AT91C_SPI_BITS_16  |AT91C_SPI_CPOL;//| AT91C_SPI_NCPHA 
  pSPI->SPI_CSR[0]=cs; 
  
  pSPI->SPI_CR = AT91C_SPI_SPIEN;
}

//====================================================================
void LCD_Write16(unsigned short int lcd_data)
{ 
 AT91PS_SPI pSPI = AT91C_BASE_SPI;
  WaitSPIFree;
  pSPI->SPI_TDR = lcd_data;
//  delaySF_ms(1);
//  return(pSPI->SPI_TDR);
}

//====================================================================
void LCD_SetCommand() //   
{
  hCS;
  delaySF_ms(1);
  lCS;
  hRS;  
}  

//====================================================================
void LCD_SetData()  //   
{
  hCS;
  delaySF_ms(1);
  lCS;
  lRS;  
} 

//====================================================================
volatile void Init_LCD(void) // 
{
  unsigned char cnt;
  hCS;
  hRESET;
  delay_ms(10);
  hRS;
  delay_ms(10);
  lCS;
  delay_ms(10); 
  
  for (cnt=0;cnt<2;cnt++) 
    LCD_Write16(INIT0[cnt]);
  delay_ms(70);
  for (cnt=0;cnt<10;cnt++) 
    LCD_Write16(INIT1[cnt]);
  delay_ms(70);
  for (cnt=0;cnt<20;cnt++) 
    LCD_Write16(INIT2[cnt]);
  delay_ms(50);
  for (cnt=0;cnt<3;cnt++) 
    LCD_Write16(INIT3[cnt]);
  delay_ms(50);
  for (cnt=0;cnt<4;cnt++) 
    LCD_Write16(INIT4[cnt]);
  delay_ms(50);
  hCS;
}

//====================================================================
void LCD_FillRect(unsigned char X1,unsigned char Y1,unsigned char X2,unsigned char Y2) //  
{
  LCD_SetCommand();
  LCD_Write16(0xEF90);
  LCD_Write16(0x0504);
  LCD_Write16((0x08<<8)+Y1);
  LCD_Write16((0x09<<8)+Y2);
  LCD_Write16((0x0A<<8)+X1);
  LCD_Write16((0x0B<<8)+X2);
}

//====================================================================
void LCD_FillScr(unsigned int color)  //   
{
  unsigned int cnt;
  //  AT91PS_SPI pSPI = AT91C_BASE_SPI;
AT91C_BASE_SPI->SPI_CSR[0]=((0x02)<<8)|AT91C_SPI_BITS_16|AT91C_SPI_CPOL;
  LCD_FillRect(0,0,175,131); 
  LCD_SetData();
 //***********************************************************
  for (cnt=0; cnt<176*132; cnt++) {
 AT91PS_SPI pSPI = AT91C_BASE_SPI;
  WaitSPIFree;
  pSPI->SPI_TDR = color;
  
  }
}  

//====================================================================
void LCD_PutPixel(unsigned char X1,unsigned char Y1,unsigned int color)  //   
{
#ifdef _buffer 
 // video_buffer[X1][Y1]=color;  
#else
  LCD_SetCommand();
  LCD_Write16(0xEF90);
  LCD_Write16(0x0504);  
  LCD_Write16((0x06<<8)+Y1);
  LCD_Write16((0x07<<8)+X1);
  LCD_SetData();
  LCD_Write16(color);
#endif  
  
} 

//====================================================================
void LCD_BlackScreen()  // 
{
 LCD_SetCommand();
 LCD_Write16(0x0040); 
}

//====================================================================
void LCD_WhiteScreen()  // 
{
 LCD_SetCommand();
 LCD_Write16(0x0080); 
}

//====================================================================
void LCD_DataScreen()  // 
{
 LCD_SetCommand();
 LCD_Write16(0x0000); 
}


//====================================================================
void LCD_WriteBuffer()  //     
{
  unsigned char cntX,cntY; 
  LCD_FillRect(0,0,LCD_WIDTH-1,LCD_HEIGHT-1); 
  LCD_SetData();
  for (cntX=0; cntX<LCD_WIDTH; cntX++){
    for (cntY=0; cntY<LCD_HEIGHT; cntY++){
      LCD_Write16(video_buffer[cntX][cntY]); 
    }
  }
}  

//====================================================================
//void LoadImage(unsigned char X1,unsigned char Y1,const unsigned int *Image) //   
void LoadImage(unsigned char X1,unsigned char Y1,const unsigned int *Image) //   
{
//  AT91PS_SPI pSPI = AT91C_BASE_SPI;
//  pSPI->SPI_CSR[0]=((0x02)<<8)|AT91C_SPI_BITS_16|AT91C_SPI_CPOL; 
  AT91C_BASE_SPI->SPI_CSR[0]=((0x02)<<8)|AT91C_SPI_BITS_16|AT91C_SPI_CPOL;
  
  LCD_FillRect(X1,Y1,X1+175,Y1+131);    
  LCD_SetData();
  Image+=1;

  AT91C_BASE_SPI->SPI_CSR[0]=((0x02)<<8)|AT91C_SPI_BITS_8|AT91C_SPI_CPOL; 

  
 AT91F_PDC_DisableTx(AT91C_BASE_PDC_SPI);
 AT91F_PDC_SetTx(AT91C_BASE_PDC_SPI, (char*)Image, (46464));
  AT91F_PDC_EnableTx(AT91C_BASE_PDC_SPI);  
  hCS;
} 

//====================================================================
void LCD_Circle(unsigned char cx, unsigned char cy ,unsigned char radius,unsigned color)
{
  int x, y, xchange, ychange, radiusError;
  x = radius;
  y = 0;
  xchange = 1 - 2 * radius;
  ychange = 1;
  radiusError = 0;
  while(x >= y)
  {
    LCD_PutPixel(cx+x, cy+y, color); 
    LCD_PutPixel(cx-x, cy+y, color); 
    LCD_PutPixel(cx-x, cy-y, color);
    LCD_PutPixel(cx+x, cy-y, color); 
    LCD_PutPixel(cx+y, cy+x, color); 
    LCD_PutPixel(cx-y, cy+x, color); 
    LCD_PutPixel(cx-y, cy-x, color); 
    LCD_PutPixel(cx+y, cy-x, color); 
    y++;
    radiusError += ychange;
    ychange += 2;
    if ( 2*radiusError + xchange > 0 )
    {
      x--;
      radiusError += xchange;
      xchange += 2;
    }
  }
}

//====================================================================
void LCD_Line(int x1, int y1, int x2, int y2)
{
  int dx = (x2 - x1 >= 0 ? 1 : -1);
  int dy = (y2 - y1 >= 0 ? 1 : -1);
  
  int lengthX,lengthY,length;
  
  //==================================       
  if (x2>=x1) {lengthX=x2-x1;} else  {lengthX=x1-x2;}     
  if (y2>=y1) {lengthY=y2-y1;} else  {lengthY=y1-y2;}
  if (lengthX > lengthY){length=lengthX;} else {length=lengthY;} 
  //==================================   
  
  if (length == 0)
  {
    LCD_PutPixel(x1, y1, RGB_BLUE);
  }
  
  if (lengthY <= lengthX)
  {
    //  
    int x = x1;
    int y = y1;
    int d = -lengthX;
    
    //  
    length++;
    while(length--)
    {
      LCD_PutPixel(x, y, RGB_BLUE);
      x += dx;
      d += 2 * lengthY;
      if (d > 0) {
        d -= 2 * lengthX;
        y += dy;
      }
    }
  }
  else
  {
    //  
    int x = x1;
    int y = y1;
    int d = - lengthY;
    
    //  
    length++;
    while(length--)
    {
      LCD_PutPixel(x, y, RGB_BLUE);
      y += dy;
      d += 2 * lengthX;
      if (d > 0) {
        d -= 2 * lengthY;
        x += dx;
      }
    }
  }
}
