#include "Board.h"

//--------------------------------------
#define LCD_HEIGHT  132 //
#define LCD_WIDTH   176 //

//--------------------------------------
#define CH_HEIGHT  14 //
#define CH_WIDTH   11 //
#define CH_CNT CH_HEIGHT*CH_WIDTH/8+1


//--------------------------------------

/*------------ LCD LS020 -------------*/
#define LED1            (1<<0)  
#define LED2            (1<<1)  
#define LCD_RS          (1<<26)	 	
#define LCD_RESET       (1<<25)		
#define LCD_CS          (1<<11)
#define LCD_CLK		(1<<14)
#define LCD_DAT		(1<<13)

#define SPI_MASK        (AT91C_PA11_NPCS0  | AT91C_PA13_MOSI | AT91C_PA14_SPCK)
#define LCD_MASK	(LCD_RS | LCD_RS | LCD_RS | AT91C_PA13_MOSI)
#define LED_MASK        (LED1|LED2)

#define hRS     AT91F_PIO_SetOutput( AT91C_BASE_PIOA,   LCD_RS)
#define lRS     AT91F_PIO_ClearOutput( AT91C_BASE_PIOA, LCD_RS)
#define hCS     AT91F_PIO_SetOutput( AT91C_BASE_PIOA,   LCD_CS)
#define lCS     AT91F_PIO_ClearOutput( AT91C_BASE_PIOA, LCD_CS)
#define hRESET  AT91F_PIO_SetOutput( AT91C_BASE_PIOA,   LCD_RESET)
#define lRESET  AT91F_PIO_ClearOutput( AT91C_BASE_PIOA, LCD_RESET)
/*---------------------------------*/

/*--------------COLOR--------------*/
#define   RGB(r,g,b)    ((r & 0x1F) << 11) + ((g & 0x3F) << 5) + (b & 0x1F)
#define   RGB_GREEN     RGB(0,63,0)
#define   RGB_BLUE      RGB(0,0,31)
#define   RGB_RED       RGB(31,0,0)
#define   RGB_GREEY     RGB(20,20,20)
#define   RGB_YELLOW    0xDEE0
#define   RGB_ORANGE    0xAB00
#define   RGB_PINK      0xF97F
#define   RGB_BROWN     0x8200
#define   RGB_GREY      0x8410
#define   RGB_VIOLET    0x91D4
#define   RGB_WHITE     0xFFFF
#define   RGB_BLACK     0x0000
/*---------------------------------*/

#define WaitSPIFree    while (!((AT91C_BASE_SPI->SPI_SR) & AT91C_SPI_TXEMPTY)) ;

/*============================================================================*/
void Init_SPI2(void);
void Init_SPI(void);
void LCD_Write16(unsigned short int lcd_data);
volatile void Init_LCD(void);
void LCD_SetData();
void LCD_SetCommand();
void LCD_FillRect(unsigned char X,unsigned char Y,unsigned char X1,unsigned char Y1);
void LCD_FillScr(unsigned int color);
void LCD_PutPixel(unsigned char X1,unsigned char Y1,unsigned int color);
void LCD_BlackScreen(); 
void LCD_WhiteScreen();  
void LCD_DataScreen();  
void LCD_WriteBuffer();
//void LoadImage(unsigned char X1,unsigned char Y1);
void LoadImage(unsigned char X1,unsigned char Y1,const unsigned int *Image); //   
void LCD_Line(int y1, int x1, int y2, int x2);
void LCD_Circle(unsigned char cy, unsigned char cx ,unsigned char radius,unsigned color);
void delay_ms(unsigned int ms);


