 #include <LPC2103.H>
 #include "ls020.h"





												 /*----------- INIT COMMAND LS020 -----------*/
const unsigned int  INIT0[2] ={0xFDFD,0xFDFD};
const unsigned int  INIT1[5] ={0xEF00,0xEE04,0x1B04,0xFEFE,0xFEFE};
const unsigned int  INIT2[5] ={0xEF90,0x4A04,0x7F3F,0xEE04,0x4306};
const unsigned int  INIT3[10]={0xEF90,0x0983,0x0800,0x0BAF,0x0A00,0x0500,0x0600,0x0700,0xEF00,0xEE0C};
const unsigned int  INIT4[6] ={0xEF90,0x0080,0xEFB0,0x4902,0xEF00,0x7F01};
const unsigned int  INIT5[1] ={0xE181};
const unsigned int  INIT6[1] ={0xE202};
const unsigned int  INIT7[1] ={0xE276};
const unsigned int  INIT8[2] ={0xE183,0x8001};
const unsigned int  INIT9[2] ={0xEF90,0x0000};
const unsigned int  INIT10[4]={0xEF90,0x0500,0x0600,0x0700};
 
//const unsigned int  INIT10[4]={0xEF90,0x0504,0x0600,0x0700};
/*------------------------------------------*/
//====================================================================
  void SPI_Init(void)
{
	IODIR |= (1 << 15)|(1 << 16)|(1 << 17);
	PINSEL0 |= (1 << 29);
	PINSEL1 |= (1 << 6) | (1 << 8);
	SSPCPSR = 2; // SCK = 1 MHz, counter > 8 and even
	SSPCR0 = 0x07; // CPHA=1, CPOL=0, master mode, MSB first, interrupt enabled
	SSPCR1 = 0x02; // CPHA=1, CPOL=0, master mode, MSB first, interrupt enabled

}
//====================================================================

void LCD_Write16(unsigned int lcd_data)
{ 
SSPDR = lcd_data>>8; 
while ((SSPSR & (1 << 0)) == 0){;}
SSPDR = lcd_data&0x00FF;
while ((SSPSR & (1 << 0)) == 0){;}
}
//===================================================================

void LCD_Write8(unsigned char lcd_data)
{ 
SSPDR = lcd_data;
while ((SSPSR & (1 << 0)) == 0){;}
}
//====================================================================
 



void delaySF_ms(unsigned int sleep)
{
	unsigned int _del;
	_del = 0xFF;
	while (_del>0) 
	_del--;
}
//====================================================================

void delay_ms(unsigned int sleep)
{
	unsigned int _del, _del2;
	_del2 = sleep;
	while (_del2 > 0){
	_del = 0x2FFF;
	while (_del>0) 
	_del--;
	 _del2--;
}

}

//====================================================================
void LCD_SetCommand() //   
{
	highCS;
	delaySF_ms(1);
	lowCS;
	highRS;  
} 

//====================================================================
void LCD_SetData()  //   
{
	highCS;
	delaySF_ms(1);
	lowCS;
	lowRS;  
} 
  
//====================================================================
volatile void Init_LCD(void) // 
{
	unsigned char cnt;
   	lowRES;
	lowRS;
	delay_ms(10);
    highRES;
	highCS;
	delay_ms(10);
	highRS;
	delay_ms(10);
	lowCS;
	delay_ms(10);
	 
	for (cnt=0;cnt<2;cnt++) 
	LCD_Write16(INIT0[cnt]);
	delay_ms(80);
	for (cnt=0;cnt<5;cnt++) 
	LCD_Write16(INIT1[cnt]);
	delay_ms(80);
	for (cnt=0;cnt<5;cnt++) 
	LCD_Write16(INIT2[cnt]);
	delay_ms(80);
	for (cnt=0;cnt<10;cnt++) 
	LCD_Write16(INIT3[cnt]);
	delay_ms(80);
	for (cnt=0;cnt<6;cnt++) 
	LCD_Write16(INIT4[cnt]);
	delay_ms(80);
	for (cnt=0;cnt<1;cnt++) 
	LCD_Write16(INIT5[cnt]);
	delay_ms(80);
    for (cnt=0;cnt<1;cnt++) 
	LCD_Write16(INIT6[cnt]);
	delay_ms(80);
	for (cnt=0;cnt<1;cnt++) 
	LCD_Write16(INIT7[cnt]);
	delay_ms(80);
	for (cnt=0;cnt<2;cnt++) 
	LCD_Write16(INIT8[cnt]);
	delay_ms(80);
	for (cnt=0;cnt<2;cnt++) 
	LCD_Write16(INIT9[cnt]);
	highCS;
}

//====================================================================
void LCD_FillRect(unsigned char X1,unsigned char Y1,unsigned char X2,unsigned char Y2) //  
{
	LCD_SetCommand();
	LCD_Write16(0xEF90);
	LCD_Write16(0x0504);
	LCD_Write16((0x08<<8)+Y1);
	LCD_Write16((0x09<<8)+Y2);
	LCD_Write16((0x0A<<8)+X1);
	LCD_Write16((0x0B<<8)+X2);
}

//====================================================================
void LCD_FillScr(unsigned int color)  //   
{
	unsigned int cnt;
	LCD_FillRect(0,0,175,131); 
	LCD_SetData();
	//***********************************************************
	for (cnt=0; cnt<176*132; cnt++) {
	LCD_Write16(color); 
	}
}  

//====================================================================
void LCD_PutPixel(unsigned char X1,unsigned char Y1,unsigned int color)  //   
{
	LCD_SetCommand();
	LCD_Write16(0xEF90);
	LCD_Write16(0x0504);  
	LCD_Write16((0x06<<8)+Y1);
	LCD_Write16((0x07<<8)+X1);
	LCD_SetData();
	LCD_Write16(color);
 
} 

//====================================================================
void LCD_BlackScreen()  // 
{
	LCD_SetCommand();
	LCD_Write16(0x0040); 
}

//====================================================================
void LCD_WhiteScreen()  // 
{
	LCD_SetCommand();
	LCD_Write16(0x0080); 
}

//====================================================================
void LCD_DataScreen()  // 
{
 LCD_SetCommand();
 LCD_Write16(0x0000); 
}
//====================================================================
//====================================================================
void LCD_Circle(unsigned char cx, unsigned char cy ,unsigned char radius,unsigned color)
{
  int x, y, xchange, ychange, radiusError;
  x = radius;
  y = 0;
  xchange = 1 - 2 * radius;
  ychange = 1;
  radiusError = 0;
  while(x >= y)
  {
    LCD_PutPixel(cx+x, cy+y, color); 
    LCD_PutPixel(cx-x, cy+y, color); 
    LCD_PutPixel(cx-x, cy-y, color);
    LCD_PutPixel(cx+x, cy-y, color); 
    LCD_PutPixel(cx+y, cy+x, color); 
    LCD_PutPixel(cx-y, cy+x, color); 
    LCD_PutPixel(cx-y, cy-x, color); 
    LCD_PutPixel(cx+y, cy-x, color); 
    y++;
    radiusError += ychange;
    ychange += 2;
    if ( 2*radiusError + xchange > 0 )
    {
      x--;
      radiusError += xchange;
      xchange += 2;
    }
  }
}

//====================================================================
//void LCD_Line(int x1, int y1, int x2, int y2)
//{
//  int dx = (x2 - x1 >= 0 ? 1 : -1);
//  int dy = (y2 - y1 >= 0 ? 1 : -1);
//  
//  int lengthX,lengthY,length;
//  
//  //==================================       
//  if (x2>=x1) {lengthX=x2-x1;} else  {lengthX=x1-x2;}     
//  if (y2>=y1) {lengthY=y2-y1;} else  {lengthY=y1-y2;}
//  if (lengthX > lengthY){length=lengthX;} else {length=lengthY;} 
//  //==================================   
//  
//  if (length == 0)
//  {
//    LCD_PutPixel(x1, y1, RGB_BLUE);
//  }
//  
//  if (lengthY <= lengthX)
//  {
//    //  
//    int x = x1;
//    int y = y1;
//    int d = -lengthX;
//    
//    //  
//    length++;
//    while(length--)
//    {
//      LCD_PutPixel(x, y, RGB_BLUE);
//      x += dx;
//      d += 2 * lengthY;
//      if (d > 0) {
//        d -= 2 * lengthX;
//        y += dy;
//      }
//    }
//  }
//  else
//  {
//    //  
//    int x = x1;
//    int y = y1;
//    int d = - lengthY;
//    
//    //  
//    length++;
//    while(length--)
//    {
//      LCD_PutPixel(x, y, RGB_BLUE);
//      y += dy;
//      d += 2 * lengthX;
//      if (d > 0) {
//        d -= 2 * lengthY;
//        x += dx;
//      }
//    }
//  }
//}
